## cron-3.0pl1.tar.bz2

=== Makefile ===
#/* Copyright 1988,1990,1993,1994 by Paul Vixie
# * All rights reserved
# *
# * Distribute freely, except: don't remove my name from the source or
# * documentation (don't take credit for my work), mark your changes (don't
# * get me blamed for your possible bugs), don't alter or remove this
# * notice.  May be sold if buildable source is provided to buyer.  No
# * warrantee of any kind, express or implied, is included with this
# * software; use at your own risk, responsibility for damages (if any) to
# * anyone resulting from the use of this software rests entirely with the
# * user.
# *
# * Send bug reports, bug fixes, enhancements, requests, flames, etc., and
# * I'll try to keep a version up to date.  I can be reached as follows:
# * Paul Vixie          <paul@vix.com>          uunet!decwrl!vixie!paul
# */

# Makefile for vixie's cron
#
# $Id: Makefile,v 2.9 1994/01/15 20:43:43 vixie Exp $
#
# vix 03mar88 [moved to RCS, rest of log is in there]
# vix 30mar87 [goodbye, time.c; hello, getopt]
# vix 12feb87 [cleanup for distribution]
# vix 30dec86 [written]

# NOTES:
#	'make' can be done by anyone
#	'make install' must be done by root
#
#	this package needs getopt(3), bitstring(3), and BSD install(8).
#
#	the configurable stuff in this makefile consists of compilation
#	options (use -O, cron runs forever) and destination directories.
#	SHELL is for the 'augumented make' systems where 'make' imports
#	SHELL from the environment and then uses it to run its commands.
#	if your environment SHELL variable is /bin/csh, make goes real
#	slow and sometimes does the wrong thing.  
#
#	this package needs the 'bitstring macros' library, which is
#	available from me or from the comp.sources.unix archive.  if you
#	put 'bitstring.h' in a non-standard place (i.e., not intuited by
#	cc(1)), you will have to define INCLUDE to set the include
#	directory for cc.  INCLUDE should be `-Isomethingorother'.
#
#	there's more configuration info in config.h; edit that first!

#################################### begin configurable stuff
#<<DESTROOT is assumed to have ./etc, ./bin, and ./man subdirectories>>
DESTROOT	=	$(DESTDIR)/usr
DESTSBIN	=	$(DESTROOT)/sbin
DESTBIN		=	$(DESTROOT)/bin
DESTMAN		=	$(DESTROOT)/share/man
#<<need bitstring.h>>
INCLUDE		=	-I.
#INCLUDE	=
#<<need getopt()>>
LIBS		= $(PAM_LIBS) $(SELINUX_LIBS) $(AUDIT_LIBS)
#<<optimize or debug?>>
OPTIM		=	-O2
#OPTIM		=	-g
#<<ATT or BSD or POSIX?>>
# (ATT untested)
#COMPAT		=	-DATT
#(BSD is only needed if <sys/params.h> does not define it, as on ULTRIX)
#COMPAT		=	-DBSD
# (POSIX)
COMPAT		=	-DPOSIX
#<<lint flags of choice?>>
LINTFLAGS	=	-hbxa $(INCLUDE) $(COMPAT) $(DEBUGGING)
#<<want to use a nonstandard CC?>>
#CC		=	vcc
#<<manifest defines>>
# Allow override from command line
DEBUG_DEFS = -DDEBUGGING=0   
# The -DUSE_SIGCHLD is needed for the Alpha port
DEFS = -DDEBIAN -DUSE_SIGCHLD $(DEBUG_DEFS) $(PAM_DEFS) $(SELINUX_DEFS)
#(SGI IRIX systems need this)
#DEFS		=	-D_BSD_SIGNALS -Dconst=
#<<the name of the BSD-like install program>>
#INSTALL = installbsd
INSTALL = install -s
#<<any special load flags>>
# LDFLAGS		=	-s
# Let install do the strip

#################################### end configurable stuff

SHELL		=	/bin/sh
CFLAGS		=	$(OPTIM) $(INCLUDE) $(COMPAT) $(DEFS)

INFOS		=	README CHANGES FEATURES INSTALL CONVERSION THANKS MAIL
MANPAGES	=	bitstring.3 crontab.5 crontab.1 cron.8 putman.sh
HEADERS		=	bitstring.h cron.h config.h pathnames.h \
			externs.h compat.h
SOURCES		=	cron.c crontab.c database.c do_command.c entry.c \
			env.c job.c user.c popen.c misc.c compat.c
SHAR_SOURCE	=	$(INFOS) $(MANPAGES) Makefile $(HEADERS) $(SOURCES)
LINT_CRON	=	cron.c database.c user.c entry.c compat.c \
			misc.c job.c do_command.c env.c popen.c
LINT_CRONTAB	=	crontab.c misc.c entry.c env.c compat.c
CRON_OBJ	=	cron.o database.o user.o entry.o job.o do_command.o \
			misc.o env.o popen.o compat.o
CRONTAB_OBJ	=	crontab.o misc.o entry.o env.o compat.o

all		:	cron crontab

lint		:
			lint $(LINTFLAGS) $(LINT_CRON) $(LIBS) \
			|grep -v "constant argument to NOT" 2>&1
			lint $(LINTFLAGS) $(LINT_CRONTAB) $(LIBS) \
			|grep -v "constant argument to NOT" 2>&1

cron		:	$(CRON_OBJ)
			$(CC) $(LDFLAGS) -o cron $(CRON_OBJ) $(LIBS)

crontab		:	$(CRONTAB_OBJ)
			$(CC) $(LDFLAGS) -o crontab $(CRONTAB_OBJ) $(LIBS)

install		:	all
			$(INSTALL) -c -m  755 -o root cron    $(DESTSBIN)/
			$(INSTALL) -c -m 4755 -o root crontab $(DESTBIN)/
			sh putman.sh crontab.1 $(DESTMAN)
			sh putman.sh cron.8    $(DESTMAN)
			sh putman.sh crontab.5 $(DESTMAN)

clean		:
			rm -f *.o cron crontab a.out core tags *~ #*

kit		:	$(SHAR_SOURCE)
			makekit -m -s99k $(SHAR_SOURCE)

$(CRON_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile
$(CRONTAB_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile

=== debian/changelog ===
cron (3.0pl1-100) unstable; urgency=low

  [ Last upload for etch fixing documentation in this package ]
  * Describe the -L option in cron's manpage.
  * Fix minor typos, and change Debian-specific content of manpages and
    default crontab that could lead to user's being confounded. Explicitly say
    that both /etc/crontab and files under /etc/cron.d/ can have users in the crontab
    lines.  (Closes: #402934)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Wed, 20 Dec 2006 00:53:06 +0100

cron (3.0pl1-99) unstable; urgency=low

  * Fix the test for anacron in /etc/crontab that would make cron run the
    run-parts regardless of wether anacron was installed or not, thanks to
    Paul Kimoto for spotting the bug introduced in the fix to #383857 
    (Closes: #392600)
  * Fix lintian error by adding a comment line in the init.d script

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Thu, 12 Oct 2006 20:49:50 +0200

cron (3.0pl1-98) unstable; urgency=low

  * Fix LSB-formatted init.d meta info, thanks to Petter Reinholdtsen 
   (Closes: #386709)
  * Make crontab tasks run with CWD=/, to make SELinux happy, thanks to
    Erich Shubert (Closes: #383857)
  * Use latest lsb logging functions, thanks to David Hardeman 
    (Closes: #384858, #389893)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Thu,  5 Oct 2006 21:03:19 +0200

cron (3.0pl1-97) unstable; urgency=high

  * Fix the behaviour of crontab so that in systems that do *not* have
    a cron.allow file users will be allowed to use crontab, change
    the behaviour of the previous version because it was contrary
    to the manpage (now a user that is in *both* cron.deny and
    cron.allow will be allowed access) (Closes: #383741)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Sat, 19 Aug 2006 10:36:48 +0200

cron (3.0pl1-96) unstable; urgency=low

  * Fix crontab.5 typo (changed quotes ' to ") that prevent a line from being
    presented (Closes: #379230)
  * Small typo fix in cron.8
  * Introduce Steve Grubb's patch to emit audit log message on crontab denial
    based on the patch from Fedora, and adapted to Debian's cron version. The
    main difference is that audit logs are generated if cron is compiled to
    'ALLOW_ONLY_ROOT'. This patch is currently disabled
    since LSPP's audit library is not yet available.
  * Change misc.c so that a user that is *both* in the cron.deny and
    cron.allow files will be denied access (previously he would be permitted
    access)
  * Add two example scripts:
     - stats-cron.pl: A script written by myself that can be used to audit
       the behaviour of cron and benefits from the new cron logging (-L 2)
       option to log the *end* of a cronjob.
     - crontab2english.pl: A script written by Sean M. Burke that translates
       the crontab notation to natural language.
  * Adjust debian/copyright to acknowledge the (c) and license of the above
    scripts.

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Wed,  9 Aug 2006 01:07:40 +0200

cron (3.0pl1-95) unstable; urgency=low

  * Handle errors when reading crontabs so that it stops reading entries in 
    a crontab file after a syntax error. This prevents a rogue user from
    dumping binary files in /etc/cron.d/ or /var/spool/cron/crontabs/ 
    and have them executed by cron (but binary files under
    /etc/cron.{daily,weekly,monthly} will still be processed as they are
    handled by run-parts. Thanks to Faidon Liambotis for the patch.
    (Closes: #378153)
  * Reuse vixie-cron-4.1-_51-bz180145-mail_i18n.patch from Fedora Core in
    order to setup a proper Content-Type when sending e-mails. The
    Content-Type will be set to the default system locale or cron's
    environment (if it modifies it). If the locale is undefined it will
    default to US ASCII (Closes: #338051)
    - There is no need to define a CHARSET variable now with the above
    patch (Closes: #309150)
  * Support kfreebsd-amd64 by modifying the Build-Depends for SElinux 
    (Closes: #361458)
  * Fix typos in the crontab.1 manpage spotted by Jonas Koelker 
    (Closes: #369153)
  * Add option to control logging (-L) with patch provided by Steve Fosdick.
    This makes it possible to log cron job finishing if you use -L 2
    (Closes: #271747, #318247)
  * Change Steve's email in crontab.c error message to
    cron@packages.debian.org 

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Wed, 19 Jul 2006 21:31:13 +0200

cron (3.0pl1-94) unstable; urgency=low

  * Lsb-base is now priority 'required' (3.0-16) instead of 'extra' 
    (3.0-15) so I'm moving the Suggests: up to a Depends:  (Closes #360236)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Sat,  1 Apr 2006 03:41:55 +0200

cron (3.0pl1-93) unstable; urgency=low

  * Include patch from Ubuntu that incorporates LSB functions to the init.
    This should help have Ubuntu synchronise their changes easier.
  * Fix FTBFS on GNU/kFreeBSD with patch from Aurelien Jarno (Closes: #338246)
  * Add brackets to the initscript for bash completion (Closes: #350605)


 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Mon, 27 Feb 2006 22:39:24 +0100

cron (3.0pl1-92) unstable; urgency=low

  * Don't use SElinux on GNU/kFreeBSD, as it is Linux-specific, patch
    from Aurelien Jarno (Closes: #325404)
  * Added LSB formatted dependency info in init.d script (Closes: #335305)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Fri, 14 Oct 2005 14:29:40 +0200

cron (3.0pl1-91) unstable; urgency=low

  * Proper fix for #324017, the previous fix was dumb. This one
    includes fixes from Fedora which should prevent segfaults under
    other circumstances.

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Sun, 21 Aug 2005 03:14:01 +0200

cron (3.0pl1-90) unstable; urgency=low

  * Fix SIGSEV due to a NULL free in the libselinux code, as a consequence
    cron dies before cronjobs are started (Closes: #324017)



=== debian/control ===
Source: cron
Section: admin
Priority: important
Maintainer: Javier Fernandez-Sanguino Pen~a <jfs@computer.org>
Uploaders: Steve Greenland <stevegr@debian.org>
Standards-Version: 3.6.1
Build-Depends: debhelper, libpam0g-dev, libselinux1-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]

Package: cron
Architecture: any
Depends: ${shlibs:Depends}, debianutils (>=1.7), adduser, lsb-base (>= 3.0-10)
Recommends: exim4 | postfix | mail-transport-agent
Suggests: anacron (>=2.0-1), logrotate, lockfile-progs, checksecurity
Conflicts: suidmanager (<< 0.50), lockfile-progs (<< 0.1.7)
Provides:
Description: management of regular background processing
 cron is a background process (`daemon') that runs programs at regular
 intervals (for example, every minute, day, week or month); which
 processes are run and at what times are specified in the `crontab'.
 .
 Users may also install crontabs so that processes are run on
 their behalf, though this feature can be disabled or restricted to
 particular users.
 .
 Output from the commands is usually mailed to the system administrator
 (or to the user in question); you should probably install a mail system
 as well so that you can receive these messages.
 .
 This cron package is configured by default to do various standard
 system maintenance tasks, such as ensuring that logfiles do not
 grow endlessly and overflow the disk.
 .
 The lockfile-progs package is only a "Suggests" because of the poor
 way that dselect handles "Recommends", but I do strongly suggest that
 you install it; it prevents /etc/cron.daily/standard from running multiple
 times if something gets jammed.

=== debian/rules ===
#!/usr/bin/make -f
# 
# Rules file for cron
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_OPTIM= -O2 -g -Wall -Wno-comment
DEB_INSTALL = install
DEB_DEBUG_DEFS = -DDEBUGGING=0

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  DEB_OPTIM = -g -Wall -Wno-comment
  DEB_DEBUG_DEFS= -DDEBUGGING=1
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  DEB_INSTALL += -s
endif

# Set system type (Linux, HURD, etc.)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
ifeq ($(DEB_HOST_ARCH_OS), linux)
  PAM_DEFS = -DUSE_PAM
  PAM_LIBS = -lpam
  SELINUX = yes
else
  PAM_DEFS = 
  PAM_LIBS =
endif

export PAM_DEFS
export PAM_LIBS

# SELinux
ifeq (yes,$(SELINUX))
  SELINUX_DEFS = -DWITH_SELINUX
  SELINUX_LIBS = -lselinux
endif

export SELINUX_DEFS SELINUX_LIBS

# Audit
ifeq (yes,$(AUDIT))
AUDIT_LIBS = -laudit
else
AUDIT_LIBS = 
endif
export AUDIT_LIBS

ifeq ($(DEB_HOST_ARCH_OS), linux)
build: build-cron build-cron-se
else
build: build-cron
endif

build-cron: b-cron/build-stamp
b-cron/build-stamp:
	dh_testdir
	rm -rf b-cron
	mkdir b-cron
	# Add here commands to compile the package.
	$(MAKE) -C b-cron -f ../Makefile OPTIM="$(DEB_OPTIM)" DEBUG_DEFS="$(DEB_DEBUG_DEFS)" VPATH=.. INCLUDE=-I.. 
	touch $@

build-cron-se: b-cron-se/build-stamp
b-cron-se/build-stamp:
	dh_testdir
	rm -rf b-cron-se
	mkdir b-cron-se
	cp debian/cron-se.overrides b-cron-se/cron-se
	cd b-cron-se
	# Add here commands to compile the package.
	SELINUX_DEFS="-DWITH_SELINUX" SELINUX_LIBS=-lselinux $(MAKE) -C b-cron-se -f ../Makefile OPTIM="$(DEB_OPTIM)" DEBUG_DEFS="$(DEB_DEBUG_DEFS)" VPATH=.. INCLUDE=-I..
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -rf b-cron b-cron-se
	rm -f debian/conffiles
	dh_clean

# Build architecture-independent files here.
binary-indep: build
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	dh_install

	dh_installdocs FEATURES THANKS README debian/README.anacron
	dh_installexamples debian/examples/*
#	dh_installmenu
	dh_installpam
	dh_installinit --noscripts
	# Can't use dh_installcron because we don't have "normal" naming
	# convention
	install -m 644 debian/crontab.main debian/cron/etc/crontab
	install -m 644 debian/placeholder debian/cron/etc/cron.d/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.hourly/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.daily/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.weekly/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.monthly/.placeholder
	install -m 755 debian/standard.daily \
                       debian/cron/etc/cron.daily/standard
	install -m 755 debian/standard.monthly \
                       debian/cron/etc/cron.monthly/standard
	dh_installman crontab.1 crontab.5 cron.8
#	dh_undocumented
	dh_installchangelogs CHANGES
	dh_installdebconf
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
#	dh_makeshlibs
	dh_md5sums
	dh_builddeb

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary
